#define _WIN32_WINNT 0x0501

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "customdrawlv.h"

#define IDM_LISTVIEW1 (100)

TCHAR g_lpszClassName[] = TEXT("_Skelton_");
HWND g_hWnd = NULL;
HWND g_hListView = NULL;


//////////////////////////////////////////////////////////////////////////


int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd) {

	WNDCLASSEX wcl;

	wcl.cbSize = sizeof(WNDCLASSEX);
	wcl.hInstance = hInstance;
	wcl.lpszClassName = g_lpszClassName;
	wcl.lpfnWndProc = WndProc;
	wcl.style = NULL;
	wcl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wcl.hIconSm = NULL;
	wcl.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcl.lpszMenuName = NULL;
	wcl.cbClsExtra = 0;
	wcl.cbWndExtra = 0;
	wcl.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);

	if(!RegisterClassEx(&wcl)) {
		return FALSE;
	}

	g_hWnd = CreateWindowEx( 
		0, 	
		g_lpszClassName,
		TEXT("Custom Draw ListView Test"),
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, 	CW_USEDEFAULT,
		350, 150,
		NULL, 
		NULL, 
		hInstance, 
		NULL);

	if(!g_hWnd) {
		return FALSE;
	}

	ShowWindow( g_hWnd, nShowCmd);
	UpdateWindow(g_hWnd);

	MSG Msg;
	
	while(GetMessage(&Msg, NULL, 0, 0)) {
		TranslateMessage(&Msg);
		DispatchMessage(&Msg);
	}

	return Msg.wParam;
	
}


//////////////////////////////////////////////////////////////////////////


LRESULT CALLBACK WndProc( HWND hwnd, UINT Msg, WPARAM wParam, LPARAM lParam) {

	switch(Msg) {
	HANDLE_MSG(hwnd, WM_CREATE, OnCreate);
	HANDLE_MSG (hwnd, WM_DESTROY, OnDestroy );
	HANDLE_MSG(hwnd, WM_SIZE, OnSize);
	HANDLE_MSG (hwnd, WM_NOTIFY, OnNotiry);
	default:
		return DefWindowProc(hwnd, Msg, wParam, lParam);
	}

	return FALSE;
}


///////////////////////////////////////////////////////////////////////////////


void SetTestData () {

	LVITEM lvi;
	ZeroMemory ( &lvi, sizeof (lvi) );

	lvi.pszText = TEXT("My name is Keisuke Oyama.");
	lvi.mask = LVIF_TEXT;
	
	INT nIndex = ListView_InsertItem( g_hListView, &lvi);

}


///////////////////////////////////////////////////////////////////////////////


BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct) {

	// ListView
	INITCOMMONCONTROLSEX cc;
	cc.dwSize = sizeof(INITCOMMONCONTROLSEX);
	cc.dwICC = ICC_LISTVIEW_CLASSES;
	InitCommonControlsEx(&cc); 

	g_hListView = CreateWindowEx(
		WS_EX_CLIENTEDGE, 
		WC_LISTVIEW, 
		(LPTSTR) NULL,
		WS_CHILD | WS_VISIBLE | LVS_REPORT | LVS_SHOWSELALWAYS , 	0, 0, 0, 0,
		hwnd, (HMENU) IDM_LISTVIEW1,
		NULL, NULL);

	LVCOLUMN lvc;
	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvc.iSubItem = 0;
	lvc.pszText = TEXT("Column #0");
	lvc.cx = 300;
	lvc.fmt = LVCFMT_LEFT;

	ListView_InsertColumn ( g_hListView, 0, &lvc);

	//
	SetTestData ();
	
	// Show Windows
	ShowWindow ( g_hListView, SW_SHOW );

	return TRUE;
}


///////////////////////////////////////////////////////////////////////////////


void OnDestroy ( HWND hwnd ) {

	PostQuitMessage(0);

}


///////////////////////////////////////////////////////////////////////////////


LRESULT OnNotiry (HWND hwnd, INT idFrom, NMHDR* pnmhdr) {

	if ( pnmhdr->code == NM_CUSTOMDRAW ) {
		LPNMLVCUSTOMDRAW lpCustomDraw = (LPNMLVCUSTOMDRAW) pnmhdr;

		switch ( lpCustomDraw->nmcd.dwDrawStage ) {
		case CDDS_PREPAINT:
			return CDRF_NOTIFYITEMDRAW;
		case CDDS_ITEMPREPAINT:
			lpCustomDraw->clrText = RGB ( 209, 0, 0);
			lpCustomDraw->clrTextBk = RGB ( 209, 240, 179);
			
			return CDRF_NEWFONT;
		}

	}

	return FORWARD_WM_NOTIFY (hwnd, idFrom, pnmhdr, DefWindowProc );

}


///////////////////////////////////////////////////////////////////////////////


void OnSize(HWND hwnd, UINT state, int cx, int cy) {

	RECT rect;
	GetClientRect ( hwnd, &rect );
	
	MoveWindow ( 
		g_hListView, 
		rect.left, // left 
		rect.top, // top, 
		rect.right - rect.left, // width
		rect.bottom - rect.top, // height
		TRUE );

}
